# CraftPresence

## [v2.5.0](https://github.com/CDAGaming/CraftPresence-Wow-Edition/tree/v2.5.0) (2022-07-27)
[Full Changelog](https://github.com/CDAGaming/CraftPresence-Wow-Edition/compare/v2.4.9...v2.5.0) [Previous Releases](https://github.com/CDAGaming/CraftPresence-Wow-Edition/releases)

- Merge branch 'next'  
- Merge branch 'master' into next  
- Merge branch 'master' into next  
- Merge branch 'master' into next  
- [Fix] Remove debug logging for production tests  
- [Refactor] Moved several methods to `CompatibilityUtils`  
    - Moved `GetFlavorInfo`, `GetFlavorTOC`, `GetCompatibilityInfo`, `FindCompatibilityInfo`, `FindCompatibilityTOC`, `IsFeatureSupported`, the helper functions to determine active flavors, `IsRebasedApi`, and `IsSpecialVersion` to new file `CompatibilityUtils`  
- [Refactor] Moved more variables to `self.internals`  
    - Added the fallback version, build, date, and toc to `self.internals.defaults`  
    - Moved `self.internals.default[Inner|Global]Key` to `self.internals.defaults.[inner|global]Key`  
- Merge branch 'master' into next  
- [Refactor] Moved several variables into `CraftPresence.cache` namespace  
    - Makes for easier debugging rather then digging through local variables.  
- [Change] Implemented `IsFeatureSupported` to internal values  
    - Fixed a minor inconsistency in the `enforceInterface` enablement code, due to how it was previously written.  
    - Added a linear progressing `baseTOC` path and resolve an issue where TurtleWow could classify as retail from the prior commit.  
    - Added caching to `IsFeatureSupported` to prevent excessive lookups.  
- [Refactor] Several Adjustments to how Compatibility and Legacy Support is handled  
    Summary:  
    - `GetCompatibilityInfo` has been rewritten from the ground-up to support TOC Ranges, feature definitions, and utilizing the expansion's name. Extra Build Info has now also been combined into this function, with `baseTOC` fields added to represent their based/rebased api version. For feature definitions, these are mostly for internal use only in order to easily control what parts of the addon are enabled/disabled in select versions rather then both having a rebased check and a toc check as things were before.  
    - Added new methods: `FindCompatibilityInfo(version, ?field)`, `FindCompatibilityTOC(key)` and `IsFeatureSupported(feature, version)`.  
      - The first function is the replacement for the now-internal-labelled `GetCompatibilityInfo` and is used to lookup and cache compatibility info (TOC info and feature definitions) for a specified game version or TOC number.  
      - To supplement this and retain old usage, `FindCompatibilityTOC` was also added in order to specifically lookup the TOC (The old field value has been renamed to `minimumTOC` to align with other settings, and the `maximumTOC` has also been added, derived from what the ending patch of an expansion cycle was from Wowpedia).  
      - The third function, `IsFeatureSupported`, is the replacement to the dual check previously required to determine which parts of the addon to enable. Ace3 will still retain the old way, since this level of refactoring is out-of-scope for what the Ace3 branch is responsible for.  
    Advanced User Migrations:  
    - `GetExtraBuildInfo` deprecated; Use `FindCompatibilityInfo`  
    - `self:GetCompatibilityInfo(version)` -> `self:FindCompatibilityTOC(version)` (Unless using the new usage)  
